<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Smile <typo3@smile.fr>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Archive formulaire Typo3' for the 'smile_form_archive' extension.
 *
 * @author	Smile <typo3@smile.fr>
 * @package	TYPO3
 * @subpackage	tx_smileformarchive
 */
class tx_smileformarchive_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_smileformarchive_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_smileformarchive_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'smile_form_archive';	// The extension key.
	var $pi_checkCHash = true;
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		// $this->pi_loadLL();
		
		// check if the archive page is correctly stored
		$page_stockage = intval($this->cObj->data['tx_smileformarchive_page_stockage']);

		if($page_stockage != 0){
			
			// check if "email" field is set
			$mail_expediteur = ( isset($_POST['email']) ? $_POST['email'] : '' );
			
			// collect POST data
			$donnees = '';
			$fields = array('html_enabled','subject','locationData','formtype_mail','email');
			foreach (t3lib_div::_POST() as $key => $value) {				
					if (!in_array($key,$fields)) {		
						$donnees .= $key . ': ' . $value . "\n";
					}
			}

			// check if there is a "mailform" content element on the referenced page
			$mail_destinataire = '';
			if($uid_mailform = $this->cObj->data['tx_smileformarchive_mailform']){

				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
	                'subheader',	// SELECT 
	                'tt_content',	// FROM 
	                'uid = '.intval($uid_mailform).' ' . $this->cObj->enableFields('tt_content'),    // WHERE
	                '',	// GROUP BY
	                '',	// ORDER BY
	                '1'	// LIMIT
	            );
				if($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
					$mail_destinataire = $row['subheader'];
				}
			}
			
			// time
			$date = mktime(0,0,0,date('m,d,Y'));
			
			// user IP address
			$IP_utilisateur = $this->cObj->data['tx_smileformarchive_store_ip'] ? $_SERVER["REMOTE_ADDR"] : ''; 
			
             // check for duplicates
            $res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
                'count(*) cnt',    // SELECT 
                'tx_smileformarchive_archive',    // FROM
                "mail_expediteur = ".$GLOBALS[TYPO3_DB]->fullQuoteStr($mail_expediteur,'tx_smileformarchive_archive').
                    " AND donnees = ".$GLOBALS[TYPO3_DB]->fullQuoteStr($donnees,'tx_smileformarchive_archive')." " .
                    $this->cObj->enableFields('tx_smileformarchive_archive'),    // WHERE
                '',    // GROUP BY
                '',    // ORDER BY
                '1'    // LIMIT
            );

            $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);

            if ($row && !$row['cnt']) {
				// insert record
				$insertArray = array(
					'pid' => $page_stockage,
				    'tstamp' => time(),
				    'crdate' => time(),
				    'date_demande' => $date,
				    'adresse_ip_internaute' => $IP_utilisateur,
				    'mail_destinataire' => $mail_destinataire,
				    'mail_expediteur' => $mail_expediteur,
				    'donnees' => $donnees,
				);

				$res = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_smileformarchive_archive', $insertArray);
			} 			
		}

		return $this->pi_wrapInBaseClass($content);
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/smile_form_archive/pi1/class.tx_smileformarchive_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/smile_form_archive/pi1/class.tx_smileformarchive_pi1.php']);
}

?>